package com.unipi.talepis;

public class Main {

    public static void main(String[] args) {
        System.out.println(Thread.currentThread().getName());
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        Thread t1 = new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    Thread.sleep(20000);
                    System.out.println("t1 finished!...");
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        });
        //t1.setDaemon(true);
        t1.start();
        MyClass m1 = new MyClass();
        Thread t2 = new Thread(m1);
        t2.start();
        new Thread(()-> System.out.println("Hello world from thread")).start();
        try {
            t1.join();
            Thread.sleep(3000);
            System.out.println("Main finished working");
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
}

class MyClass implements Runnable{
    @Override
    public void run() {
        System.out.println("Hello from MyClass");
    }
}
